#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string MacdPeriods = "12,26,9;24,52,18";
extern int    Price     = PRICE_CLOSE;
extern bool   UseOsma   = false;

double histUp[];
double histDn[];
double histNe[];
double periods[][3];
string speriods[];
int    totalPeriods;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,histUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,histNe); SetIndexStyle(2,DRAW_HISTOGRAM);
      MacdPeriods = StringTrimLeft(StringTrimRight(MacdPeriods));
      if (StringSubstr(MacdPeriods,StringLen(MacdPeriods)-1,1) != ";")
                       MacdPeriods = StringConcatenate(MacdPeriods,";");

      //
      //
      //
      //
      //
                             
         int s =  0;
         int i =  StringFind(MacdPeriods,";",s);
         while (i > 0)
         {
            string current = StringSubstr(MacdPeriods,s,i-s);
            ArrayResize(speriods,ArraySize(speriods)+1);
                        speriods[ArraySize(speriods)-1] = current;
            s = i + 1;
            i = StringFind(MacdPeriods,";",s);
         }

         //
         //
         //
         //
         //
         
         totalPeriods = MathMin(ArraySize(speriods),20);
         ArrayResize(periods,totalPeriods);
         for (int k=0; k<totalPeriods; k++)
         {
            speriods[k] = speriods[k]+",";
            int p = 0;
                s = 0;
                i = StringFind(speriods[k],",",s);
                while (i > 0)
                {
                     current = StringSubstr(speriods[k],s,i-s);
                     periods[k][p] = StrToInteger(current);
                        s = i + 1;
                        i = StringFind(speriods[k],",",s);
                        p++;
                }                     
         }
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][160];
#define _fastEma 0
#define _slowEma 1
#define _signEma 2
#define _hist    3
#define _trend   4
#define _state   5
#define _currmx  6
#define _currmn  7

int start() 
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
         
         
         //
         //
         //
         //
         //
         

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double max   = 0;
      double sum   = 0;
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      for (int k=0; k<totalPeriods; k++)
      {
         int    kk = k*8;
         double alphaF = 2.0/(1.0+periods[k][0]);
         double alphaS = 2.0/(1.0+periods[k][1]);
         double alphaI = 2.0/(1.0+periods[k][2]);
            work[r][kk+_fastEma] = work[r-1][kk+_fastEma]+alphaF*(price-work[r-1][kk+_fastEma]);
            work[r][kk+_slowEma] = work[r-1][kk+_slowEma]+alphaS*(price-work[r-1][kk+_slowEma]);
         double macd = work[r][kk+_fastEma]-work[r][kk+_slowEma];
         if (UseOsma)
         {
            work[r][kk+_signEma] = work[r-1][kk+_signEma]+alphaI*(macd -work[r-1][kk+_signEma]);
            work[r][kk+_hist]    = macd-work[r][kk+_signEma];
         }            
         else work[r][kk+_hist] = macd;   
              work[r][kk+_trend]  = work[r-1][kk+_trend];
              work[r][kk+_currmx] = work[r-1][kk+_currmx];
              work[r][kk+_currmn] = work[r-1][kk+_currmn];
              work[r][kk+_state]  = 0;
                  if (work[r][kk+_hist]>0) { work[r][kk+_trend] =  1; work[r][kk+_currmn] = 0; if (work[r][kk+_hist]>work[r][kk+_currmx]) { work[r][kk+_currmx]=work[r][kk+_hist]; work[r][kk+_state]= 1; }}
                  if (work[r][kk+_hist]<0) { work[r][kk+_trend] = -1; work[r][kk+_currmx] = 0; if (work[r][kk+_hist]<work[r][kk+_currmn]) { work[r][kk+_currmn]=work[r][kk+_hist]; work[r][kk+_state]=-1; }}
                      sum += work[r][kk+_state];
                      max++;
      }                      
     
      //
      //
      //
      //
      //
        
      histUp[i] = EMPTY_VALUE;
      histDn[i] = EMPTY_VALUE;
      histNe[i] = EMPTY_VALUE;
         if (sum== max) histUp[i] = 1;
         if (sum==-max) histDn[i] = 1;
         if (histUp[i]==EMPTY_VALUE && histDn[i]==EMPTY_VALUE) histNe[i] = 1;
   }     
   return(0);
}